#pragma once

#include "String.h"
#include <iostream>
#include <filesystem>
#include Map.h
#include "Vector.h"

using Path = std::filesystem::path;

class SiteGeneratorConfig;
class ContentPage;
class ContentArticle;
class TemplatingEngine;

class WebsiteGenerator
{
public:
    WebsiteGenerator();

    ~WebsiteGenerator();

    void doSubstitutions();

    void findProject(const String& searchPath);

    void parseContentFiles();

    void parseTemplateFiles();

    void readConfig();

    void write();

private:
    void findContentFiles();

    Path getContentPath() const;

    Path getPagesPath() const;

    Path getArticlesPath() const;

    Path getConfigPath() const;

    Path getOutputPath() const;

    std::filesystem::path mProjectPath;

    Ptr<SiteGeneratorConfig> mConfig;
    Ptr<TemplatingEngine> mTemplateEngine;

    Vector<Ptr<ContentPage> > mPages;
    Vector<Ptr<ContentArticle> > mArticles;
};
