#!/usr/bin/env bash

SCRIPT_DIR=$( cd -- "$( dirname -- "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )
SOURCE_DIR=$SCRIPT_DIR/src
CORE_SRC_DIR=$SOURCE_DIR/base/core

g++ $SOURCE_DIR/main.cpp \
       $CORE_SRC_DIR/base_types/Error.cpp \
       $CORE_SRC_DIR/base_types/Index.cpp \
       $CORE_SRC_DIR/base_types/Char.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildEnvironment.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildConfig.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildBinary.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildTarget.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildLibrary.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildExecutable.cpp \
       $SOURCE_DIR/base/compiler/buildsystem/BuildSession.cpp \
       $CORE_SRC_DIR/data_structures/String.cpp \
       $CORE_SRC_DIR/filesystem/FileSystemPath.cpp \
       $CORE_SRC_DIR/filesystem/File.cpp \
       $CORE_SRC_DIR/filesystem/FileFormats.cpp \
       $CORE_SRC_DIR/filesystem/posix/FilePosixImpl.cpp \
       $CORE_SRC_DIR/filesystem/Directory.cpp \
       $CORE_SRC_DIR/logging/ConsoleLogger.cpp \
       $CORE_SRC_DIR/logging/Logger.cpp \
       $CORE_SRC_DIR/serialization/yaml/YamlDocuments.cpp \
       $CORE_SRC_DIR/serialization/yaml/YamlDocument.cpp \
       $CORE_SRC_DIR/serialization/yaml/YamlParser.cpp \
       $CORE_SRC_DIR/streams/FileStream.cpp \
       $CORE_SRC_DIR/streams/Stream.cpp \
       $CORE_SRC_DIR/system/process/Process.cpp \
       $CORE_SRC_DIR/time/Time.cpp \
       -o builder -g -fno-exceptions -fno-rtti \
        -I$CORE_SRC_DIR/base_types \
        -I$SOURCE_DIR/base/compiler/buildsystem \
        -I$CORE_SRC_DIR/data_structures \
        -I$CORE_SRC_DIR/encoding \
        -I$CORE_SRC_DIR/filesystem \
        -I$CORE_SRC_DIR/filesystem/posix \
        -I$CORE_SRC_DIR/logging \
        -I$CORE_SRC_DIR/memory \
        -I$CORE_SRC_DIR/serialization/yaml \
        -I$CORE_SRC_DIR/streams \
        -I$CORE_SRC_DIR/system/process \
        -I$CORE_SRC_DIR/time
        
