#pragma once

#include "AbstractVisualNode.h"

#include "ElectronicCircuit.h"

#include Map.h

class WireNode;
class TerminalNode;
class LogicGateNode;
class Wire;
class CircuitElementNode;

class ElectronicCircuitNode : public AbstractVisualNode
{
public:
    ElectronicCircuitNode(const Transform& transform);

    virtual ~ElectronicCircuitNode();

    void setContent(ElectronicCircuit* content);

    void update(SceneInfo* sceneInfo);

private:
    void createOrUpdateGeometry(SceneInfo* sceneInfo);

    void buildWireConnections();

    ElectronicCircuit* mContent{ nullptr };
    bool mContentDirty{ true };

    Vector<Ptr<TerminalNode> > mInputTerminalNodes;
    Vector<Ptr<TerminalNode> > mOutputTerminalNodes;
    Vector<Ptr<WireNode> > mWireNodes;
    Vector<Ptr<LogicGateNode> > mLogicGateNodes;

    Map<Wire*, CircuitElement*> mWireInputConnections;
    Map<Wire*, CircuitElement*> mWireOutputConnections;

    Map<CircuitElement*, CircuitElementNode*> mNodesForContent;
};
