#pragma once

#include "BuildTarget.h"

class BuildBinary : public BuildTarget
{
public:
    BuildBinary(BuildTargetType binary_type);

    BuildBinary(Ptr<BuildConfig> config);

    virtual ~BuildBinary() = default;

    Status build() override;

    Status configure(const BuildEnvironment& env) override;

    const Vector<FileSystemPath>& get_sources() const;

private:
    void add_include_dirs(Vector<String>& args);

    Status populate_sources_dirs();

    Status create_archive();

    Status compile_sources();

    Status compile_file(const FileSystemPath& source);

    Vector<String> m_compiler_flags;
    String m_compiler_command;
    String m_archive_command;
    FileSystemPath m_build_dir;
    Vector<String> m_public_header_dependencies;
    Vector<FileSystemPath> m_sources;
};