#pragma once

#include "FileSystemPath.h"
#include "YamlDocuments.h"
#include "Error.h"
#include "BuildTargetType.h"

class BuildConfig
{
public:
    BuildConfig() = default;

    BuildConfig(const FileSystemPath& path);

    Status load();

    FileSystemPath get_directory() const;

    String get_directory_name() const;

    BuildTargetType get_target_type() const;

private:
    BuildTargetType m_type{BuildTargetType::STATIC_LIBRARY};
    YamlDocuments m_content;
    FileSystemPath m_path;
};