#include "BuildEnvironment.h"

BuildEnvironment::BuildEnvironment(const FileSystemPath& source_dir, 
    const FileSystemPath& build_dir)
    : m_build_dir(build_dir),
      m_source_dir(source_dir)
{
    m_compiler_flags.push_back("-g");
    m_compiler_flags.push_back("-fno-exceptions");
    m_compiler_flags.push_back("-fno-rtti");
}

const Vector<String>& BuildEnvironment::get_compiler_flags() const
{
    return m_compiler_flags;
}

const String& BuildEnvironment::get_compiler_command() const
{
    return m_compiler_command;
}

const String& BuildEnvironment::get_archive_command() const
{
    return m_archive_command;
}

const FileSystemPath& BuildEnvironment::get_build_dir() const
{
    return m_build_dir;
}

const FileSystemPath& BuildEnvironment::get_source_dir() const
{
    return m_source_dir;
}

FileSystemPath BuildEnvironment::get_test_dir() const
{
    return m_source_dir / "test";
}

void BuildEnvironment::set_build_dir(const FileSystemPath& dir)
{
    m_build_dir = dir;
}