#pragma once

#include "Vector.h"
#include "FileSystemPath.h"

class BuildEnvironment
{
public:
    BuildEnvironment(const FileSystemPath& source_dir, const FileSystemPath& build_dir = {});

    const Vector<String>& get_compiler_flags() const;

    const String& get_compiler_command() const;

    const String& get_archive_command() const;

    const FileSystemPath& get_build_dir() const;

    const FileSystemPath& get_source_dir() const;

    FileSystemPath get_test_dir() const;

    void set_build_dir(const FileSystemPath& dir);

private:
    String m_compiler_command{"/usr/bin/g++"};
    String m_archive_command{"/usr/bin/ar"};
    Vector<String> m_compiler_flags;
    FileSystemPath m_build_dir;
    FileSystemPath m_source_dir;
};