#pragma once

#include "BuildEnvironment.h"
#include "BuildTarget.h"
#include "FileSystemPath.h"
#include "Error.h"
#include "Pointer.h"

class BuildSession
{
public:
    BuildSession(const FileSystemPath& source_dir, 
        const FileSystemPath& build_dir = {});

    Status build();

    Status configure();

private:
    Status add_target(const FileSystemPath& config_path);

    Status configure_tests();

    BuildEnvironment m_build_environment;
    Vector<Ptr<BuildTarget> > m_targets;
};