#pragma once

#include "Error.h"

template<typename T>
class Result
{
public:
    Result(const T& val = T())
        : m_value(val)
    {

    }

    Result(const Error& error)
        : m_error(error),
            m_ok(false)
    {

    }

    void on_error(const Error& error)
    {
        m_error = error;
        m_ok = false;
    }

    const Error& error() const 
    {
        return m_error;
    }

    bool ok() const 
    {
        return m_ok;
    }

    const T& value() const 
    {
        return m_value;
    }

    T& value() 
    {
        return m_value;
    }

private:
    T m_value;
    Error m_error;
    bool m_ok{true};
};