#include "Dictionary.h"

Dictionary::Dictionary(const String& item)
    : mType(Type::SCALAR),
        mScalarType(ScalarType::STRING),
        mStringVal(item)
{
}

void Dictionary::addItem(const String& key, Ptr<Dictionary> dict)
{
    mMapVal.insert(key, std::move(dict));
}

void Dictionary::addItem(const String& key, const String& item)
{
    mMapVal.insert(key, Ptr<Dictionary>::create(item));
}

Vector<String> Dictionary::getKeys() const
{
    Vector<String> keys;
    for (const auto& item : mMapVal)
    {
        keys.push_back(item.key());
    }
    return keys;
}

Dictionary* Dictionary::getItemAsMap(const String& key) const
{
    if (isMap())
    {
        return (*mMapVal.find(key)).value().get();
    }
    return nullptr;
}

Optional<String> Dictionary::getItemAsString(const String& key) const
{
    if (isString())
    {
        return mStringVal;
    }
    return {};
}

bool Dictionary::hasKey(const String& key) const
{
    return mMapVal.has_key(key);
}

bool Dictionary::isMap() const
{
    return mType == Type::MAP;
}

bool Dictionary::isString() const
{
    return mType == Type::SCALAR && mScalarType == ScalarType::STRING;
}




