#pragma once

template<typename T, typename U>
class Pair 
{
public:
    Pair() = default;

    Pair(const T& t, const U& u)
        : m_first(t),
            m_second(u)
    {

    }

    const T& first() const
    {
        return m_first;
    }

    const U& second() const 
    {
        return m_second;
    }

private:
    T m_first;
    U m_second;
};