#pragma once

#include "Pointer.h"
#include "Optional.h"

template<typename T>
class Stack
{
    struct StackItem
    {
        StackItem(const T& value, Ptr<StackItem> prev)
            : m_value(value),
             m_previous(std::move(prev))
        {
        }

        T m_value;
        Ptr<StackItem> m_previous;
    };

public:

    bool empty() const 
    {
        return !bool(m_end);
    }

    Optional<T> pop()
    {
        if (!m_end)
        {
            return {};
        }
        auto end_tmp = m_end->m_value;
        remove_end();
        return end_tmp;
    }

    T* top()
    {
        if (!m_end)
        {
            return nullptr;
        }
        return &(m_end->m_value);
    }

    void push(const T& value)
    {
        //auto new_end = Ptr<StackItem>::create(value, std::move(m_end));
        //m_end = std::move(new_end);
    }

private:
    void remove_end()
    {
        if (m_end)
        {
            if (m_end->m_previous)
            {
                m_end = std::move(m_end->m_previous);
            }
            else
            {
                m_end.reset();
            }
        }
    }

    Ptr<StackItem> m_end;
};