#pragma once

#include "FileFormats.h"
#include "FileSystemPath.h"
#include "String.h"
#include "Byte.h"
#include "Pointer.h"

class FilePosixImpl;

class File
{
public:
    enum class AccessMode{
        Read,
        Write
    };

public:
    File(const FileSystemPath& path);

    ~File();

    Status close();

    bool exists() const;

    bool finished() const;

    String getExtension() const;

    FileFormat::Format inferFormat() const;

    Status open(AccessMode mode);

    Status read(VecBytes& bytes);

    Status read(String& buffer);

    Status write(const String& buffer);

    Status write(const VecBytes& bytes);

private:
    Ptr<FilePosixImpl> m_impl;
    FileSystemPath m_path;
    bool mGotEndOfFile{false};
};
