#pragma once

#include "Map.h"
#include "String.h"

class FileFormat{

public:
    enum class Encoding{
        Ascii,
        UTF8,
        Binary
    };

    enum class Format{
        Html,
        Xml,
        Markdown,
        Pdf,
        Json,
        Png,
        Wav,
        Midi,
        Unknown
    };

    using ExtensionMap = Map<Format, String>;
public:
    static bool isFormat(const String& extension, Format format);

    static Format inferFormat(const String& query);

    static String getExtension(Format format);

private:
    static ExtensionMap mExtensions;
};

