#pragma once

#include "FileSystemPath.h"
#include "File.h"

class FilePosixImpl
{
public:
    Status do_open(const FileSystemPath& path, 
        File::AccessMode accessMode);

    Status do_close();

    bool is_ok() const;

    bool is_open_for_read() const;

    bool is_open_for_write() const;

    Result<size_t> do_read(VecBytes& bytes);

    Result<size_t> do_write(const VecBytes& bytes);

    Result<size_t> do_write(const Vector<char>& bytes, int size = -1);

    Status update_size();

    bool m_open_for_write{false};
    bool m_open_for_read{false};
    bool m_valid{false};
    size_t m_size{0};
    bool m_is_open{false};
    int m_fd{-1};
};