#include "FileLogger.h"

#include "FileSystemPath.h"

FileLogger::FileLogger()
    :mWorkDirectory(),
        mFileName("MT_Log.txt")
{

}

FileLogger::~FileLogger()
{

}

void FileLogger::SetWorkDirectory(const String& workDir)
{
    mWorkDirectory = workDir;
}

void FileLogger::SetFileName(const String& fileName)
{
    mFileName = fileName;
}

void FileLogger::Open()
{
    if (mWorkDirectory.empty())
    {
        mWorkDirectory = FileSystemPath::current_dir().value().str();
    }
    //mFileStream.open(mWorkDirectory + "/" + mFileName);
}

void FileLogger::Close()
{
    //mFileStream.close();
}

void FileLogger::disable()
{
    mDisabled = true;
}

void FileLogger::log_line(Level level, 
        const String& line, 
        const String& fileName, 
        const String& functionName, 
        int lineNumber)
{
    if (mDisabled)
    {
        return;
    }

    const auto log_msg = build_log_message(level, 
        line, 
        fileName, 
        functionName, 
        lineNumber);
    if (level == Level::INFO)
    {
        //printf("%s\n", log_msg.raw());
    }
    else
    {
        //fprintf(stderr, "%s\n", log_msg.raw());
    }
}
