#pragma once

#include "String.h"
#include "Vector.h"
#include "Map.h"

class HttpHeader
{
public:
    HttpHeader();
    void parse(const Vector<String >& message);

    String getContentType() const;

    String getHttpVersion() const;

private:
    String mHttpVersion;
    String mContentType;
    String mHost;
    String mUserAgent;
    String mAccept;
    String mAcceptLanguage;
    String mAcceptEncoding;
    String mConnection;
    String mReferer;
    String mSecFetchDest;
    String mSecFetchMode;
    String mSecFetchSite;

    Map<String, String> mOtherFields;
};
