#pragma once

#include "HttpHeader.h"
#include "HttpPreamble.h"

#include "String.h"

class HttpResponse
{
public:
    struct ClientError
    {
        String mMessage;
        int mCode{ -1 };
    };

    HttpResponse();

    ~HttpResponse();

    void fromMessage(const String& message);

    unsigned getBodyLength() const;

    const String& getBody() const;

    const HttpHeader& getHeader() const;

    String getHeaderString() const;

    String toString() const;

    unsigned short getStatusCode() const;

    const String& getResponseReason() const;

    void setStatusCode(unsigned short code);

    void setResponseReason(const String& reason);

    void setBody(const String& body);

    void setClientError(const ClientError& error);

private:
    HttpPreamble mPreamble;
    HttpHeader mHeader;

    ClientError mClientError;
    unsigned short mStatusCode{ 200 };
    String mResponseReason{ };
    String mBody;
};
