#pragma once 

#include "FileSystemPath.h"
#include "IOStream.h"
#include "JsonDocument.h"

class JsonParser
{
public:
    Ptr<JsonDocument> read(const FileSystemPath& input_file);

    Ptr<JsonDocument> read(InputStream<Byte>& stream);

private:
    enum class State 
    {
        READY,
        IN_OBJECT,
        IN_ARRAY,
        IN_STRING,
        IN_NUMBER
    };
};