#include "FileStream.h"

InputFileStream::InputFileStream(const FileSystemPath& path)
    : m_file(path),
      m_buffer(Vector<Byte>(m_buffer_size))
{

}

bool InputFileStream::finished() const
{
    return m_end_of_stream == true;
}

bool InputFileStream::get(Byte& item)
{
    if (m_buffer_offset >= m_buffer_current_size)
    {
        if (m_end_of_file)
        {
            m_end_of_stream = true;
            return false;
        }

        m_buffer_offset = 0;
        if (const auto rc = m_file.read(m_buffer); !rc.ok())
        {
            on_error(rc);
            return false;
        }
        m_buffer_current_size = m_buffer.size();
        if (m_buffer_current_size < m_buffer_size)
        {
            m_end_of_file = true;
        }
        if (m_buffer_current_size == 0)
        {
            m_end_of_stream = true;
            return false;
        }
        item = m_buffer[m_buffer_offset];
        m_buffer_offset++;
        return true;
    }
    else 
    {
        item = m_buffer[m_buffer_offset];
        m_buffer_offset++;
        return true;     
    }
}

bool InputFileStream::good() const
{
    return !m_end_of_stream && Stream::good();
}


