#pragma once

#include "Byte.h"
#include "IOStream.h"
#include "FileSystemPath.h"
#include "File.h"
#include "Vector.h"

class InputFileStream : public InputStream<Byte>
{
public:
    InputFileStream(const FileSystemPath& path);

    bool finished() const;

    bool good() const override;

    bool get(Byte& item);

private:
    File m_file;
    bool m_end_of_file{false};
    bool m_end_of_stream{false};
    size_t m_buffer_offset{0};
    size_t m_buffer_current_size{0};
    size_t m_buffer_size{4096};
    Vector<Byte> m_buffer;
    Status mStatus;
};