#pragma once

#include "BitStream.h"
#include "IOStream.h"
#include "Byte.h"

class OutputBitStream : public BitStream
{
public:
    OutputBitStream(OutputStream<Byte>* stream);

    bool isFinished() const override;

    void peekNextNBytes(size_t n, VecBytes& bytes) const override;

    bool readNextByte(Byte& buffer) override;

    void writeByte(Byte data, bool checkOverflow = true) override;

    void writeBytes(const VecBytes& data) override;

private:
    OutputStream<Byte>* mStream{nullptr};
};
