#include "StringStream.h"

StringStream::StringStream(const String& str)
{
    str.to_bytes(m_buffer);
}

bool StringStream::finished() const
{
    return m_end_of_stream;
}

bool StringStream::good() const
{
    return !m_end_of_stream && InputStream<Byte>::good();
}

bool StringStream::get(Byte& item)
{
    if (m_end_of_stream)
    {
        return false;
    }
    if (m_offset >= m_buffer.size())
    {
        m_end_of_stream = true;
        return false;
    }
    item = m_buffer[m_offset];
    m_offset++;
    return true;
}