#pragma once

#include "Bounds.h"

#include "Vector.h"
#include "Pointer.h"

class AbstractGrid
{
public:
    AbstractGrid(const Bounds& bounds, size_t numPointsX, size_t numPointsY, size_t numPointsZ = 1);

    virtual ~AbstractGrid();

    const Bounds& getBounds() const;

    virtual size_t getDataSize() const = 0;

    double getXSpacing() const;

    double getYSpacing() const;

    void resetBounds(const Bounds& bounds);

protected:
    Bounds mBounds;
    size_t mNumX{ 0 };
    size_t mNumY{ 0 };
    size_t mNumZ{ 0 };
};
