#pragma once

#include "Point.h"
#include "Transform.h"
#include "Bounds.h"

#include "Vector.h"

template<size_t DIM>
class PointCollection
{
public:
    PointCollection(const Vector<Point<DIM> > points = {});

    void addPoint(const Point<DIM>& point);

    void apply(const Transform& transform);

    Bounds getBounds() const;

    Point<DIM> getEndPoint() const;

    const Vector<Point<DIM> >& getPoints() const;

private:
    Vector<Point<DIM> > mPoints;
};
