#pragma once

#include "String.h"
#include <functional>

class Socket;

class PlatformSocketServer
{
public:
	struct Address
	{
		String mPrefix;
		String mHost;
		unsigned int mPort{8000};
	};

	struct Result
	{
		enum class Status
		{
			OK,
			FAILED
		};

		Status mStatus{ Status::FAILED };
		String mErrorMessage;
		int mErrorCode{ -1 };
		String mBody;
	};

	using onConnectionSuccessFunc = std::function<void(Socket*)>;
	using onConnectionFailedFunc = std::function<void(const Result&)>;
	virtual void listen(const Address& address, onConnectionSuccessFunc connectionSuccessFunc, onConnectionFailedFunc connectionFailedFunc) = 0;

	virtual void shutDown() {};
};