#include "BuildSession.h"
#include "ConsoleLogger.h"
#include "FileSystemPath.h"

int main(int argc, char** argv)
{
    if (argc <= 1)
    {
        LOG_ERROR("Missing arg with path to source dir");
        return -1;
    }

    FileSystemPath source_path(argv[1]);
    BuildSession build(source_path);
    if (const auto rc = build.configure(); !rc.ok())
    {
        LOG_ERROR("Configure failed with " << rc);
        return -1;
    }

    if (const auto rc = build.build(); !rc.ok())
    {
        LOG_ERROR("Build failed with " << rc);
        return -1;
    }
    return 0;
}
