#pragma once

#include "IAudioInterface.h"
#include "AudioDevice.h"

#include "Pointer.h"
#include "Vector.h"

class AudioSample;

class AudioManager
{

public:
    AudioManager();

    ~AudioManager();

    static Ptr<AudioManager> Create();

    void addAudioDevice(AudioDevicePtr device);

    size_t getNumAudioDevices() const;

    AudioDevice* getAudioDevice(unsigned idx) const;

    void play(AudioSample* sample, unsigned duration);

private:
    Vector<AudioDevicePtr> mAudioDevices;
    IAudioInterfacePtr mAudioInterface;
};

using AudioManagerUPtr = Ptr<AudioManager>;
