#pragma once

#include "Image.h"
#include "IImageWriter.h"
#include "DeflateElements.h"

#include "Pointer.h"
#include "String.h"

class PngWriter : public IImageWriter
{
public:
    PngWriter();
    ~PngWriter();

    static Ptr<PngWriter> Create();

    void setCompressionMethod(Deflate::CompressionMethod method);

    void write(const Path& path, Image* image) override;

private:
    Ptr<IImageWriter> mWriterImpl;
};

using PngWriterPtr = Ptr<PngWriter>;
