#pragma once

#include "PdfDictionary.h"

#include "Pointer.h"
#include "String.h"
#include "Vector.h"

class PdfDocumentCatalog;
using PdfDocumentCatalogPtr = Ptr<PdfDocumentCatalog>;

class PdfXRefTable;
using PdfXRefTablePtr = Ptr<PdfXRefTable>;

class PdfDocument
{
public:
    PdfDocument();
    ~PdfDocument();

    String toString();
private:
    String getHeaderString();

    String getTrailerString();

    String getBodyString();

    String getXRefString();

    void indexObjects();

private:
    PdfDictionary mTrailer;

    String mVersion {"1.7"};
    PdfXRefTablePtr mXRefTable;
    size_t mXRefOffset{0};
    PdfDocumentCatalogPtr mCatalog;
};

using PdfDocumentPtr = Ptr<PdfDocument>;
