#pragma once

#include "PdfDictionary.h"

#include "Pointer.h"
#include "String.h"

class PdfXRefTable;

class PdfObject
{
public:
    virtual ~PdfObject() = default;

    String getStringPrefix() const;

    String getStringSuffix() const;

    String getRefString() const;

    virtual unsigned indexObjects(unsigned count);

    bool isFree() const;

    virtual String toString(PdfXRefTable* xRefTable);

    void setObjectNumber(unsigned num);

    void setGenerationNumber(unsigned num);

protected:
    virtual void updateDictionary();

    unsigned mObjectNumber{0};
    unsigned mGenerationNumber{0};
    PdfDictionary mDictionary;
    bool mIsFree {false};
};
using PdfObjectPtr = Ptr<PdfObject>;
