#pragma once

#include "String.h"
#include "Pointer.h"
#include "Vector.h"

struct XRefRecord
{
    size_t mOffsetBytes{0};
    size_t mGenerationNumber{0};
    bool mIsFree{false};
};

struct TableSubSection
{
    size_t mStartIndex{0};
    Vector<XRefRecord> mRecords;
};

class PdfXRefTable
{
public:
    PdfXRefTable();

    void addRecord(size_t numBytes, size_t generation, unsigned isFree);

    size_t getNextOffset();

    size_t getNumEntries();

    String toString();
private:
    size_t mLastAddedBytes{0};
    Vector<TableSubSection> mSections;
};
