#pragma once

#include "FontItem.h"

#include "Pointer.h"
#include <filesystem>

class FontGlyph;

class IFontEngine
{
public:
    IFontEngine() = default;
    virtual ~IFontEngine() = default;

    virtual void initialize(){};

    virtual void loadFontFace(const std::filesystem::path& fontFile, float penSize = 16) = 0;

    virtual Ptr<FontGlyph> loadGlyph(uint32_t charCode) = 0;

    virtual double getHorizontalAdvance(const FontItem& fontItem, const String& content) = 0;
};
