#pragma once

#include "Point.h"

#include "Pointer.h"
#include "Vector.h"
#include Map.h
#include "String.h"

class Edge;

class AbstractFace
{
public:

    enum class Orientation
    {
        CW,
        CCW
    };

    AbstractFace(size_t id=0);

    virtual ~AbstractFace();

    virtual Vector<size_t> getNodeIds() const = 0;

    void addVectorAttribute(const String& tag, const Vector<double>& values);

    Vector<double> getVectorAttribute(const String& tag) const;

    virtual size_t getNumNodes() const = 0;

    virtual void associateWidthEdges() = 0;

    virtual Vector<size_t> getEdgeIds() const = 0;

    virtual Vector<Point3> getNodeLocations(Orientation orientation = Orientation::CCW) const = 0;

    virtual void replaceEdge(Edge* original, Edge* replacement) = 0;

    void setIndex(size_t idx);

protected:
    size_t mId{0};
    Map<String, Vector<double> > mVectorAttributes;
};
