#pragma once

#include "TriMesh.h"
#include "LineMesh.h"

class MeshPrimitives
{
public:
    static Ptr<TriMesh> buildCircleAsTriMesh(size_t numSegments = 24);

    static Ptr<LineMesh> buildCircleAsLineMesh(size_t numSegments = 24);

    static Ptr<TriMesh> buildRectangleAsTriMesh();

    static Ptr<LineMesh> buildRectangleAsLineMesh();

    static Ptr<TriMesh> buildExplodedGridAsTriMesh(size_t numX, size_t numY);

    static Ptr<LineMesh> buildExplodedGridAsLineMesh(size_t numX, size_t numY);

    static Ptr<TriMesh> buildRoundedRectangleAsTriMesh(double radius, double aspect_ratio = 1.0, size_t num_segments = 4);
};
