#pragma once

#include <Point.h>
#include "String.h"

namespace ntk
{
	class Arc;
}

template<size_t DIM>
class QuadraticBezierCurve;

template<size_t DIM>
class CubicBezierCurve;

template<size_t DIM>
class Line;

template<size_t DIM>
class LineSegment;

template<size_t DIM>
class PathElement;

class GeometryPath;

class PostscriptWriter
{
public:
	void setPrecision(size_t precision);

	String toString(GeometryPath* path);

private:
	String toString(PathElement<2>* pathElement);

	String toString(Line<2>* line);

	String toString(LineSegment<2>* line);

	String toString(ntk::Arc* arc);

	String toString(QuadraticBezierCurve<2>* curve);

	String toString(CubicBezierCurve<2>* curve);

	size_t mPrecision{ 3 };
	Point2 mCursor;
};