#pragma once

#include "AbstractDesktopApp.h"
#include "UiInterfaceFactory.h"
#include "CommandLineArgs.h"

#include "Pointer.h"

class MainApplication;
class DesktopManager;
class AbstractUiInterface;

class GuiApplication : public AbstractDesktopApp
{
public:
    GuiApplication(Ptr<CommandLineArgs> args = nullptr, Ptr<MainApplication> mainApp = nullptr);

    ~GuiApplication();

    AbstractApp* getMainApplication() const override;

    AbstractUIInterface* getUiInterface() const override;

    void setUiInterfaceBackend(UiInterfaceFactory::Backend backend);

    void run();

protected:
    virtual void initializeViews();

    Ptr<DesktopManager> mDesktopManager;
    Ptr<MainApplication> mMainApplication;

private:
    UiInterfaceFactory::Backend mUiInterfaceBackend = UiInterfaceFactory::Backend::UNSET;
    Ptr<AbstractUIInterface> mUiInterface;
};
