#pragma once

#include "Widget.h"

#include "String.h"

class TextNode;

class Label : public Widget
{

public:

    Label();

    virtual ~Label() = default;

    static Ptr<Label> Create();

    void setLabel(const String& text);

private:
    bool isDirty() const override;
    void doPaint(const PaintEvent* event) override;

    void updateLabel(const PaintEvent* event);

    String mLabel;
    Ptr<TextNode> mTextNode;
    bool mContentDirty{true};

};

using LabelUPtr = Ptr<Label>;
