#pragma once

#include "Pointer.h"

class Keyboard;
class MouseEvent;
class KeyboardEvent;
class PaintEvent;

struct xcb_key_press_event_t;
struct xcb_button_press_event_t;

class XcbEventInterface
{
public:
    static Ptr<XcbEventInterface> Create();

    Ptr<KeyboardEvent> convertKeyPress(xcb_key_press_event_t* event, Keyboard* keyboard) const;

    Ptr<KeyboardEvent> convertKeyRelease(xcb_key_press_event_t* event, Keyboard* keyboard) const;

    Ptr<MouseEvent> convertButtonPress(xcb_button_press_event_t* event) const;

    Ptr<MouseEvent> convertButtonRelease(xcb_button_press_event_t* event) const;
};

using XcbEventInterfacePtr = Ptr<XcbEventInterface>;
